apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ console_name }}
  name: {{ console_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ console_replicas }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ console_name }}
  strategy:
    type: RollingUpdate
{% else %}
    name: {{ console_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Rolling
{% endif %}
  template:
    metadata:
      labels:
        name: {{ console_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
      automountServiceAccountToken: false
      containers:
      - args:
        - server
        env:
        - name: CONSOLE_ACCESS_KEY
          valueFrom:
            secretKeyRef:
              key: access-key
              name: {{ minio_name }}-admin
        - name: CONSOLE_MINIO_SERVER
          value: http://{{ minio_name }}-client.{{ namespace }}.svc.{{ cluster_domain }}:9000
        - name: CONSOLE_PBKDF_PASSPHRASE
          valueFrom:
            secretKeyRef:
              key: pbkdf-passphrase
              name: {{ console_name }}
        - name: CONSOLE_PBKDF_SALT
          valueFrom:
            secretKeyRef:
              key: pbkdf-salt
              name: {{ console_name }}
        - name: CONSOLE_SECRET_KEY
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ minio_name }}-admin
{% if do_triggers == False or (opsimages | json_query("[?name=='minio_console'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='minio_console'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 20
          initialDelaySeconds: 20
          periodSeconds: 20
          tcpSocket:
            port: 9090
          timeoutSeconds: 3
        name: console
        ports:
        - containerPort: 9090
        readinessProbe:
          failureThreshold: 5
          httpGet:
            path: /api/v1/login
            port: 9090
          initialDelaySeconds: 20
          periodSeconds: 10
          timeoutSeconds: 2
        resources:
          limits:
            cpu: "{{ console_cpu_limit }}"
            memory: "{{ console_memory_limit }}"
          requests:
            cpu: "{{ console_cpu_request }}"
            memory: "{{ console_memory_request }}"
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
      securityContext:
        runAsUser: {{ k8s_unprivileged_userid }}
{% else %}
      securityContext: {}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ console_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
{% if (do_triggers | default(False)) != False %}
  triggers:
{% if (opsimages | json_query("[?name=='minio_console'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - console
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='minio_console'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
